//Team Colors
local MULTITEAM_TEAMCOLOR = {
	SKINCOLOR_RED,
	SKINCOLOR_BLUE,
	SKINCOLOR_YELLOW,
	SKINCOLOR_GREEN,
	SKINCOLOR_PINK,
	SKINCOLOR_PURPLE,
	SKINCOLOR_ORANGE,
	SKINCOLOR_CYAN
}
//Team Scores
local TeamScores = {0,0,0,0,0,0,0,0}
local MultiteamRoundEnd = false
local inMultiteam = false

local function MULTITEAM_JoinTeam(playernum,team)
	if players[playernum] and players[playernum].valid == true and
	players[playernum].mo and players[playernum].mo.valid == true and
	inMultiteam == true then
		players[playernum].skincolor = MULTITEAM_TEAMCOLOR[team]
		players[playernum].mo.color = MULTITEAM_TEAMCOLOR[team]
		players[playernum].multiteam = team
	end
end

CV_RegisterVar({
	name = "multiteam_numberofteams",
	defaultvalue = 2,
	flags = CV_CALL|CV_NETVAR,
	PossibleValue = {MIN = 2, MAX = 8},
	func = function()
		if inMultiteam == true then
			for i = 0,31 do
				if players[i] and players[i].valid == true and
				players[i].multiteam ~= (i % CV_FindVar("multiteam_numberofteams").value)+1 and players[i].multiteam ~= nil and players[i].mo then
					P_KillMobj(players[i].mo) //Player Die because of switching Teams
				end
				MULTITEAM_JoinTeam(i,(i % CV_FindVar("multiteam_numberofteams").value)+1)
			end
		end
	end
})

COM_AddCommand("multiteam_join",function(player,team)
	local teamvalue = CV_FindVar("multiteam_numberofteams").value
	if splitscreen == false and inMultiteam == true then
		if team and type(tonumber(team)) == "number" then
			if tonumber(team) >= 1 and tonumber(team) <= teamvalue then
				if player.multiteam ~= tonumber(team) and player.mo then
					P_KillMobj(player.mo) //Player Die because of switching Teams
				end
				MULTITEAM_JoinTeam(#player,tonumber(team))
			elseif tonumber(team) > teamvalue and player == consoleplayer then
				print("You cannot join future teams")
			elseif player == consoleplayer
				print("This is TEAM 0")
			end
		elseif player == consoleplayer then
			print("multiteam_join <Team>")
			print("\x85".."1\x80 - Red")
			print("\x84".."2\x80 - Blue")
			if teamvalue >= 3 then
				print("\x82".."3\x80 - Yellow")
			end
			if teamvalue >= 4 then
				print("\x83".."4\x80 - Green")
			end
			if teamvalue >= 5 then
				print("\x8E".."5\x80 - Pink")
			end
			if teamvalue >= 6 then
				print("\x89".."6\x80 - Purple")
			end
			if teamvalue >= 7 then
				print("\x87".."7\x80 - Orange")
			end
			if teamvalue >= 8 then
				print("\x88".."8\x80 - Cyan")
			end
		end
	elseif inMultiteam == false then
		if player == consoleplayer then
			print("This only works on Multiteam Gametype")
		end
	else
		print("Doesn't work in Splitscreen")
	end
end)

addHook("PlayerSpawn", function(player)
	if inMultiteam == true and player.multiteam == nil or player.multiteam == 0 or player.multiteam > CV_FindVar("multiteam_numberofteams").value then
		MULTITEAM_JoinTeam(#player,(#player % CV_FindVar("multiteam_numberofteams").value)+1)
	end
end)

//FORCE TEAM COLOR
addHook("PlayerThink", function(player)
	if inMultiteam == true and player.mo and player.mo.valid == true then
		if player.multiteam then
			player.skincolor = MULTITEAM_TEAMCOLOR[player.multiteam]
			player.mo.color = MULTITEAM_TEAMCOLOR[player.multiteam]
		end
	end
end)

//Damage Other Teams
addHook("ShouldDamage",function(trg,inf,src,d,dt)
	if inMultiteam == true and trg and trg.player and src and src.player then
		if trg.player.multiteam == src.player.multiteam then
			return false
		end
	end
end,MT_PLAYER)

//Scoreboard
addHook("ThinkFrame", function()
	if MultiteamRoundEnd == false and inMultiteam == true then
		for i = 1,8 do
			TeamScores[i] = 0
			for player in players.iterate() do
				if player.multiteam ~= i then
					continue
				end
				TeamScores[i] = $1+player.score
			end
			if pointlimit > 0 and TeamScores[i] >= pointlimit then
				MultiteamRoundEnd = true
				G_ExitLevel()
			end
		end
	end
	if inMultiteam == true then
		if hud.enabled("rankings") == true then hud.disable("rankings") end
		if hud.enabled("intermissiontally") == true then hud.disable("intermissiontally") end
	end
	if gametype == GT_MULTITEAMMATCH and inMultiteam == false then
		inMultiteam = true
	elseif gametype ~= GT_MULTITEAMMATCH and inMultiteam == true then
		inMultiteam = false
		//ENABLE HUD
		hud.enable("rankings")
		hud.enable("intermissiontally")
	end
end)

local function MULTITEAM_SCOREBOARD(v)
	if inMultiteam == true then
		local v_teamname = "NULL"
		local v_teamcolor = V_REDMAP
		local v_playernum = 0
		local teamposy1 = 0
		local teamposy2 = 0
		for teamnum = 1,CV_FindVar("multiteam_numberofteams").value do
			v_playernum = 0
			local v_posmap = 0
			if teamnum == 1 then
				v_teamname = "Red"
				v_teamcolor = V_REDMAP
			elseif teamnum == 2 then
				v_teamname = "Blue"
				v_teamcolor = V_BLUEMAP
			elseif teamnum == 3 then
				v_teamname = "Yellow"
				v_teamcolor = V_YELLOWMAP
			elseif teamnum == 4 then
				v_teamname = "Green"
				v_teamcolor = V_GREENMAP
			elseif teamnum == 5 then
				v_teamname = "Pink"
				v_teamcolor = V_ROSYMAP
			elseif teamnum == 6 then
				v_teamname = "Purple"
				v_teamcolor = V_PURPLEMAP
			elseif teamnum == 7 then
				v_teamname = "Orange"
				v_teamcolor = V_ORANGEMAP
			elseif teamnum == 8 then
				v_teamname = "Cyan"
				v_teamcolor = V_SKYMAP
			end
			if teamnum > CV_FindVar("multiteam_numberofteams").value/2 then
				v_posmap = $1|V_SNAPTOBOTTOM
			else
				v_posmap = $1|V_SNAPTOTOP
			end
			if teamnum % 2 == 0 then
				v_posmap = $1|V_SNAPTORIGHT
			else
				v_posmap = $1|V_SNAPTOLEFT
			end
			local teamposx = 80
			local teamposy = teamposy1
			if teamnum % 2 == 0 then
				teamposx = 240
				teamposy = teamposy2
			end
			v.drawString(teamposx,teamposy,v_teamname.." Team",v_teamcolor|v_posmap|V_ALLOWLOWERCASE,"center")
			for player in players.iterate() do
				if player.multiteam ~= teamnum then
					continue
				end
				v_playernum = $1+1
				v.drawString(teamposx,teamposy+(8*v_playernum),player.name..": "..player.score,v_posmap|V_ALLOWLOWERCASE,"center")
			end
			v.drawString(teamposx,teamposy+(8*(v_playernum+1)),"TOTAL: "..TeamScores[teamnum],v_teamcolor|v_posmap,"center")
			if teamnum % 2 == 1 then
				teamposy1 = teamposy+(8*(v_playernum+2))
			else
				teamposy2 = teamposy+(8*(v_playernum+2))
			end
		end
	end
end

G_AddGametype({
	name = "Multiteam",
	identifier = "multiteammatch",
	typeoflevel = TOL_MATCH|TOL_TAG|TOL_CTF,
	rules = GTR_RINGSLINGER|GTR_SPECTATORS|GTR_FIRSTPERSON|GTR_POWERSTONES|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_HURTMESSAGES|GTR_RESPAWNDELAY|GTR_PITYSHIELD|GTR_DEATHMATCHSTARTS|GTR_SPAWNINVUL,
	intermissiontype = int_match,
	defaulttimelimit = 10,
	defaultpointlimit = 0,
	headerleftcolor = 83,
	headerrightcolor = 99,
	description = "Play Match with Multiple Teams and Get the Most Score on the Same Team Wins!"
})

addHook("MapChange", function()
	TeamScores = {0,0,0,0,0,0,0,0}
	MultiteamRoundEnd = false
	if gametype == GT_MULTITEAMMATCH and inMultiteam == false then
		inMultiteam = true
	elseif gametype ~= GT_MULTITEAMMATCH and inMultiteam == true then
		inMultiteam = false
		//ENABLE HUD
		hud.enable("rankings")
		hud.enable("intermissiontally")
	end
end)

hud.add(MULTITEAM_SCOREBOARD,"scores")
hud.add(MULTITEAM_SCOREBOARD,"intermission")

hud.add(function(v)
	if inMultiteam == true and consoleplayer then
		if timelimit > 0 then
			local teamtimer = (timelimit*(TICRATE*60))-consoleplayer.realtime+TICRATE
			local teamtimerword = (G_TicsToMinutes(teamtimer,true)..":"..G_TicsToSeconds(teamtimer))
			if teamtimer % (TICRATE*60) < TICRATE*10 then
				teamtimerword = (G_TicsToMinutes(teamtimer,true)..":0"..G_TicsToSeconds(teamtimer))
			end
			v.drawString(10,184,"Time Left: "..teamtimerword,V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_SNAPTOLEFT,"left")
		end
		if pointlimit > 0 then
			v.drawString(10,192,"Score Limit: "..pointlimit,V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_SNAPTOLEFT,"left")
		end
	end
end,"scores")