//TEAM RACE and TEAM COMP
G_AddGametype({
	name = "Team Race",
	identifier = "teamrace",
	typeoflevel = TOL_RACE,
	rules = GTR_TEAMS|GTR_RACE|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL|GTR_SPAWNENEMIES|GTR_ALLOWEXIT,
	rankingtype = GT_RACE,
	intermissiontype = int_teammatch,
	headerleftcolor = 32,
	headerrightcolor = 146,
	description = "Play Race with 2 Teams, Teleporter Monitor Chance Disabled and The Team get's Railed when the player of the Team passes the checkpoint."
})

G_AddGametype({
	name = "Team Competition",
	identifier = "teamcompetition",
	typeoflevel = TOL_COMPETITION,
	rules = GTR_LIVES|GTR_TEAMS|GTR_EMERALDTOKENS|GTR_RACE|GTR_NOSPECTATORSPAWN|GTR_SPAWNINVUL|GTR_SPAWNENEMIES|GTR_ALLOWEXIT,
	rankingtype = GT_COMPETITION,
	intermissiontype = int_teammatch,
	headerleftcolor = 71,
	headerrightcolor = 253,
	description = "Play Competition with Limited Lives and 2 Teams, Teleporter Monitor Chance Disabled and Checkpoint are Shared for Both Teams"
})

local redteamplayers = {}
local blueteamplayers = {}
local redteamcheckpoint = 0
local blueteamcheckpoint = 0
local redteamcheckpointowner = nil
local blueteamcheckpointowner = nil

local function teamrace_teamcheckpoints(team,checkpoint,owner)
	for player = 1,#team do
		if team[player].starpostnum < checkpoint then
			team[player].starpostnum = checkpoint
			if owner then
				team[player].starpostx = owner.starpostx
				team[player].starposty = owner.starposty
				team[player].starpostz = owner.starpostz
				team[player].starposttime = owner.starposttime
				team[player].starpostangle = owner.starpostangle
				team[player].starpostscale = owner.starpostscale
				if gametype == GT_TEAMRACE then
					//Teleport Players
					if team[player].mo then
						P_TeleportMove(team[player].mo,owner.starpostx*FRACUNIT,owner.starposty*FRACUNIT,owner.starpostz*FRACUNIT)
						team[player].drawangle = owner.starpostangle
						team[player].mo.angle = owner.starpostangle
						team[player].mo.scale = owner.starpostscale
						team[player].mo.momx = 0
						team[player].mo.momy = 0
						team[player].mo.momz = 0
					end
				end
				//Plays the Sound
				S_StartSound(nil,sfx_strpst,team[player])
			end
		end
	end
end

addHook("ThinkFrame",function()
	if circuitmap == false then //Not compatable for Circuit Map
		redteamplayers = {}
		blueteamplayers = {}
		//Get Players
		for player in players.iterate() do
			if (gametype ~= GT_TEAMRACE and gametype ~= GT_TEAMCOMPETITION) or player.playerstate ~= PST_LIVE or player.exiting ~= 0 or player.spectator == true then
				continue
			end
			if player.ctfteam == 1 then
				table.insert(redteamplayers,player)
			elseif player.ctfteam == 2 then
				table.insert(blueteamplayers,player)
			end
			//Finds Checkpoints for you
			if player.ctfteam == 1 and player.starpostnum > redteamcheckpoint then
				redteamcheckpoint = player.starpostnum
			redteamcheckpointowner = player
			elseif player.ctfteam == 2 and player.starpostnum > blueteamcheckpoint then
				blueteamcheckpoint = player.starpostnum
				blueteamcheckpointowner = player
			end
		end
		//Get and Set the Checkpoints for Both Teams
		if #redteamplayers >= 2 then
			teamrace_teamcheckpoints(redteamplayers,redteamcheckpoint,redteamcheckpointowner)
		end
		if #blueteamplayers >= 2 then
			teamrace_teamcheckpoints(blueteamplayers,blueteamcheckpoint,blueteamcheckpointowner)
		end
	end
end)

addHook("MapChange",function()
	redteamcheckpoint = 0
	blueteamcheckpoint = 0
	redteamcheckpointowner = nil
	blueteamcheckpointowner = nil
end)

addHook("PlayerSpawn",function(player)
	if (gametype == GT_TEAMRACE or gametype == GT_TEAMCOMPETITION) and player.ctfteam == 0 then
		if #blueteamplayers < #redteamplayers then
			COM_BufInsertText(player,"changeteam blue")
			if splitscreen == true then
				COM_BufInsertText(player,"changeteam2 red")
			end
		else
			COM_BufInsertText(player,"changeteam red")
			if splitscreen == true then
				COM_BufInsertText(player,"changeteam2 blue")
			end
		end
	end
end)

addHook("MobjSpawn", function(obj)
	if gametype == GT_TEAMRACE or gametype == GT_TEAMCOMPETITION then
		obj.type = MT_RECYCLER_BOX
		obj.state = S_RECYCLER_BOX
	end
end,MT_MIXUP_BOX)

addHook("MobjSpawn", function(obj)
	if gametype == GT_TEAMRACE or gametype == GT_TEAMCOMPETITION then
		obj.type = MT_RECYCLER_ICON
		obj.state = S_RECYCLER_ICON1
	end
end,MT_MIXUP_ICON)

addHook("TeamSwitch", function(player,team,fromspectators,autobalance,scramble)
	if (gametype == GT_TEAMRACE or gametype == GT_TEAMCOMPETITION) and fromspectators == false and leveltime >= TICRATE*4 and autobalance == false and scramble == false and
	(player.pflags == player.pflags & ~PF_GAMETYPEOVER & ~PF_FINISHED) and player.lives ~= 0 and player.exiting == 0 then
		if player == consoleplayer then
			print("You can't Change your Team during the middle of the race.")
		end
		return false
	end
end)

addHook("NetVars",function(netvar)
	redteamcheckpoint = netvar(redteamcheckpoint)
	blueteamcheckpoint = netvar(blueteamcheckpoint)
	redteamcheckpointowner = netvar(redteamcheckpointowner)
	blueteamcheckpointowner = netvar(blueteamcheckpointowner)
end)